(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.unknown = mod.exports;
  }
})(this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  !function (global) {
    "use strict";

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    var inModule = typeof module === "object";
    var runtime = global.regeneratorRuntime;

    if (runtime) {
      if (inModule) {
        module.exports = runtime;
      }

      return;
    }

    runtime = global.regeneratorRuntime = inModule ? module.exports || {} : {};

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self, context);
      return generator;
    }

    runtime.wrap = wrap;

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};

    IteratorPrototype[iteratorSymbol] = function () {
      return this;
    };

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
    GeneratorFunctionPrototype.constructor = GeneratorFunction;
    GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        prototype[method] = function (arg) {
          return this._invoke(method, arg);
        };
      });
    }

    runtime.isGeneratorFunction = function (genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };

    runtime.mark = function (genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;

        if (!(toStringTagSymbol in genFun)) {
          genFun[toStringTagSymbol] = "GeneratorFunction";
        }
      }

      genFun.prototype = Object.create(Gp);
      return genFun;
    };

    runtime.awrap = function (arg) {
      return {
        __await: arg
      };
    };

    function AsyncIterator(generator) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;

          if (value && typeof value === "object" && hasOwn.call(value, "__await")) {
            return Promise.resolve(value.__await).then(function (value) {
              invoke("next", value, resolve, reject);
            }, function (err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return Promise.resolve(value).then(function (unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new Promise(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }

      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);

    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
      return this;
    };

    runtime.AsyncIterator = AsyncIterator;

    runtime.async = function (innerFn, outerFn, self, tryLocsList) {
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
      return runtime.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          }

          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;
          var record = tryCatch(innerFn, self, context);

          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (method === undefined) {
        context.delegate = null;

        if (context.method === "throw") {
          if (delegate.iterator.return) {
            context.method = "return";
            context.arg = undefined;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;

        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined;
        }
      } else {
        return info;
      }

      context.delegate = null;
      return ContinueSentinel;
    }

    defineIteratorMethods(Gp);
    Gp[toStringTagSymbol] = "Generator";

    Gp[iteratorSymbol] = function () {
      return this;
    };

    Gp.toString = function () {
      return "[object Generator]";
    };

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    runtime.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      keys.reverse();
      return function next() {
        while (keys.length) {
          var key = keys.pop();

          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        }

        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];

        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined;
            next.done = true;
            return next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    runtime.values = values;

    function doneResult() {
      return {
        value: undefined,
        done: true
      };
    }

    Context.prototype = {
      constructor: Context,
      reset: function (skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined;
        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined;
            }
          }
        }
      },
      stop: function () {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;

        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },
      dispatchException: function (exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;

        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            context.method = "next";
            context.arg = undefined;
          }

          return !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function (type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },
      complete: function (record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },
      finish: function (finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function (tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function (iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          this.arg = undefined;
        }

        return ContinueSentinel;
      }
    };
  }(function () {
    return this || typeof self === "object" && self;
  }() || Function("return this")());
  const disableBlocks = {
    debug: [],
    upload: []
  };
  const mustLoginBlocks = [];

  const triggerBlocksStatus = async (mode, app) => {};

  class ExtImpl {}

  const extTranslationMap = {
    "zh": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "de": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "es": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "fr": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "id": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "ja": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "ja-jph": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "ko": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "pl": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "uk": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "zh-hant": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "nl": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "it": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "hr": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "ru": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "pt": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "fi": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "tr": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "tk": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    },
    "en": {
      "vdr_grove_divers": "vdr grove divers",
      "extensionName": "vdr grove divers",
      "extensionDescription": "Blocks programmation pour LED, bouton, poussoir Buzzer, potentiometre Aduino",
      "BLOCK_1654891253229": "preview block",
      "BLOCK_1654891387215": "Pour [forVar] de [min] à [max] par [step] ",
      "BLOCK_1654891387430_NUM_0": "1",
      "BLOCK_1654891387430_NUM_1": "2",
      "BLOCK_1654891387430_NUM_2": "3",
      "BLOCK_1654891387430_NUM_3": "4",
      "BLOCK_1654891387430_NUM_4": "5",
      "BLOCK_1654891387430_NUM_5": "6",
      "BLOCK_1654891387430_NUM_6": "7",
      "BLOCK_1654891387430_NUM_7": "8",
      "BLOCK_1654891387430_NUM_8": "9",
      "BLOCK_1654891387430": "Initialise timer [num] ",
      "BLOCK_1654891387629": "Timer [num] > [time] ",
      "BLOCK_1654891387838_PINSDIGIT_0": "D2",
      "BLOCK_1654891387838_PINSDIGIT_1": "D3",
      "BLOCK_1654891387838_PINSDIGIT_2": "D4",
      "BLOCK_1654891387838_PINSDIGIT_3": "D5",
      "BLOCK_1654891387838_PINSDIGIT_4": "D6",
      "BLOCK_1654891387838_PINSDIGIT_5": "D7",
      "BLOCK_1654891387838_PINSDIGIT_6": "D8",
      "BLOCK_1654891387838_ONOFF_0": "Activer",
      "BLOCK_1654891387838_ONOFF_1": "Désactiver",
      "BLOCK_1654891387838_ONOFF_2": "inverser",
      "BLOCK_1654891387838": "LED sur\n[pinsDigit]\n[onOff] ",
      "BLOCK_1654891388053_ETAT_0": "Activer",
      "BLOCK_1654891388053_ETAT_1": "Désactiver",
      "BLOCK_1654891388053": "Si bouton poussoir [pinsDigit] [etat] ",
      "BLOCK_1654891388253_PINANALOGIQUE_0": "A0",
      "BLOCK_1654891388253_PINANALOGIQUE_1": "A1",
      "BLOCK_1654891388253_PINANALOGIQUE_2": "A2",
      "BLOCK_1654891388253_PINANALOGIQUE_3": "A3",
      "BLOCK_1654891388253_GROVE_VCC_0": "3,5V",
      "BLOCK_1654891388253_GROVE_VCC_1": "5V",
      "BLOCK_1654891388253": "Angle potentiomètre sur [pinAnalogique] voltage [Grove_VCC] Valeur Max [angleMax] ",
      "BLOCK_1654891388445_NOTE_0": "do",
      "BLOCK_1654891388445_NOTE_1": "re",
      "BLOCK_1654891388445_NOTE_2": "mi",
      "BLOCK_1654891388445_NOTE_3": "fa",
      "BLOCK_1654891388445_NOTE_4": "sol",
      "BLOCK_1654891388445_NOTE_5": "la",
      "BLOCK_1654891388445_NOTE_6": "si",
      "BLOCK_1654891388445": "Buzzer sur [pinDigit] jouer [note] pendant [duree] s",
      "cate_a6173b07": "divers"
    }
  };
  const codeSnippets = {
    arduinoc: {}
  };
  const extGenerators = [{
    lang: 'arduinoc',
    template: `// generated by mBlock5 for <your product>
// codes make you happy

//( include //)
#include <Arduino.h>
//( lib //)

//({
    this.$ALL_VARIABLES.length==0?'':this.$ALL_VARIABLES.map(v=>"float "+v+" = 0;").join('\\n')
}//)

//( declare //)


void _delay(float seconds) {
  long endTime = millis() + seconds * 1000;
  while(millis() < endTime) _loop();
}

//(
void setup() {
  //( setup //)
  //( code //)
}
//)

void _loop() {
  //( _loop //)
}

void loop() {
  _loop();
}`,
    splitor: {
      frame: {
        left: "//(",
        right: "//)"
      },
      expression: {
        left: "/*{",
        right: "}*/"
      }
    },
    reducers: [{
      name: 'include',
      reduce: codes => {
        let codes1 = [];

        for (let code of codes) {
          let codeStr = '';

          if (typeof code === 'string') {
            codeStr = code;
          } else if (typeof code === 'function') {
            codeStr = code();
          }

          if (codes1.indexOf(codeStr) === -1) {
            codes1.push(codeStr);
          }
        }

        if (codes1.length === 0) {
          return undefined;
        }

        return codes1.map(code => {
          return '#include ' + code;
        }).join('\n') + '\n';
      }
    }]
  }];
  const extSources = {
    arduino: [{
      filename: "src/LowPower.cpp",
      code: "/*******************************************************************************\n* LowPower Library\n* Version: 1.81\n* Date: 21-01-2020\n* Author: Lim Phang Moh\n* Company: Rocket Scream Electronics\n* Website: www.rocketscream.com\n*\n* This is a lightweight low power library for Arduino.\n*\n* This library is licensed under Creative Commons Attribution-ShareAlike 3.0\n* Unported License.\n*\n* Revision  Description\n* ========  ===========\n* 1.81      Fixed timer 2 settings incorrectly restored after sleep.\n*           Contributed by rwared11.\n* 1.80      Added support for ATmega88 and ATmega168P. PowerExtStandby()\n*           modified because not supported on Atmega88 / Atmega168\n*           Contributed by mrguen.\n* 1.70      Added support for ATmega644P and ATmega1284P.\n*           Contributed by alexreinert.\n* 1.60      Added support for ATmega256RFR2. Contributed by Rodmg.\n* 1.50      Fixed compiler optimization (Arduino IDE 1.6.x branch) on BOD enable\n*           function that causes the function to be over optimized.\n* 1.40\t\tAdded support for ATSAMD21G18A.\n* \t\t\tLibrary format compliant with Arduino IDE 1.5.x.\n* 1.30\t\tAdded support for ATMega168, ATMega2560, ATMega1280 & ATMega32U4.\n*\t\t\tTested to work with Arduino IDE 1.0.1 - 1.0.4.\n* 1.20\t\tRemove typo error in idle method for checking whether Timer 0 was\n*\t\t\tturned off.\n*\t\t\tRemove dependecy on WProgram.h which is not required.\n*\t\t\tTested to work with Arduino IDE 1.0.\n* 1.10\t\tAdded #ifndef for sleep_bod_disable() for compatibility with future\n*\t\t\tArduino IDE release.\n* 1.00      Initial public release.\n*******************************************************************************/\n#if defined (__AVR__)\n\t#include <avr/sleep.h>\n\t#include <avr/wdt.h>\n\t#include <avr/power.h>\n\t#include <avr/interrupt.h>\n#elif defined (__arm__)\n\n#else\n\t#error \"Processor architecture is not supported.\"\n#endif\n\n#include \"LowPower.h\"\n\n#if defined (__AVR__)\n// Only Pico Power devices can change BOD settings through software\n#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168P__)\n#ifndef sleep_bod_disable\n#define sleep_bod_disable() \t\t\t\t\t\t\t\t\t\t\\\ndo { \t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\\\n  unsigned char tempreg; \t\t\t\t\t\t\t\t\t\t\t\t\t\\\n  __asm__ __volatile__(\"in %[tempreg], %[mcucr]\" \"\\n\\t\" \t\t\t\\\n                       \"ori %[tempreg], %[bods_bodse]\" \"\\n\\t\" \t\t\\\n                       \"out %[mcucr], %[tempreg]\" \"\\n\\t\" \t\t\t\\\n                       \"andi %[tempreg], %[not_bodse]\" \"\\n\\t\" \t\t\\\n                       \"out %[mcucr], %[tempreg]\" \t\t\t\t\t\\\n                       : [tempreg] \"=&d\" (tempreg) \t\t\t\t\t\\\n                       : [mcucr] \"I\" _SFR_IO_ADDR(MCUCR), \t\t\t\\\n                         [bods_bodse] \"i\" (_BV(BODS) | _BV(BODSE)), \\\n                         [not_bodse] \"i\" (~_BV(BODSE))); \t\t\t\\\n} while (0)\n#endif\n#endif\n\n#define\tlowPowerBodOn(mode)\t\\\ndo { \t\t\t\t\t\t\\\n      set_sleep_mode(mode); \\\n      cli();\t\t\t\t\\\n      sleep_enable();\t\t\\\n      sei();\t\t\t\t\\\n      sleep_cpu();\t\t\t\\\n      sleep_disable();\t\t\\\n      sei();\t\t\t\t\\\n} while (0);\n\n// Only Pico Power devices can change BOD settings through software\n#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168P__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega1284P__)\n#define\tlowPowerBodOff(mode)\\\ndo { \t\t\t\t\t\t\\\n      set_sleep_mode(mode); \\\n      cli();\t\t\t\t\\\n      sleep_enable();\t\t\\\n\t\t\tsleep_bod_disable(); \\\n      sei();\t\t\t\t\\\n      sleep_cpu();\t\t\t\\\n      sleep_disable();\t\t\\\n      sei();\t\t\t\t\\\n} while (0);\n#endif\n\n// Some macros is still missing from AVR GCC distribution for ATmega32U4\n#if defined __AVR_ATmega32U4__\n\t// Timer 4 PRR bit is currently not defined in iom32u4.h\n\t#ifndef PRTIM4\n\t\t#define PRTIM4 4\n\t#endif\n\n\t// Timer 4 power reduction macro is not defined currently in power.h\n\t#ifndef power_timer4_disable\n\t\t#define power_timer4_disable()\t(PRR1 |= (uint8_t)(1 << PRTIM4))\n\t#endif\n\n\t#ifndef power_timer4_enable\n\t\t#define power_timer4_enable()\t\t(PRR1 &= (uint8_t)~(1 << PRTIM4))\n\t#endif\n#endif\n\n/*******************************************************************************\n* Name: idle\n* Description: Putting ATmega328P/168 into idle state. Please make sure you\n*\t\t\t         understand the implication and result of disabling module.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period   Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control:\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. timer2\t\tTimer 2 module disable control:\n*\t\t\t\t(a) TIMER2_OFF - Turn off Timer 2 module\n*\t\t\t\t(b) TIMER2_ON - Leave Timer 2 module in its default state\n*\n* 4. timer1\t\tTimer 1 module disable control:\n*\t\t\t\t(a) TIMER1_OFF - Turn off Timer 1 module\n*\t\t\t\t(b) TIMER1_ON - Leave Timer 1 module in its default state\n*\n* 5. timer0\t\tTimer 0 module disable control:\n*\t\t\t\t(a) TIMER0_OFF - Turn off Timer 0 module\n*\t\t\t\t(b) TIMER0_ON - Leave Timer 0 module in its default state\n*\n* 6. spi\t\tSPI module disable control:\n*\t\t\t\t(a) SPI_OFF - Turn off SPI module\n*\t\t\t\t(b) SPI_ON - Leave SPI module in its default state\n*\n* 7. usart0\t\tUSART0 module disable control:\n*\t\t\t\t(a) USART0_OFF - Turn off USART0  module\n*\t\t\t\t(b) USART0_ON - Leave USART0 module in its default state\n*\n* 8. twi\t\tTWI module disable control:\n*\t\t\t\t(a) TWI_OFF - Turn off TWI module\n*\t\t\t\t(b) TWI_ON - Leave TWI module in its default state\n*\n*******************************************************************************/\n#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168__) || defined (__AVR_ATmega168P__) || defined (__AVR_ATmega88__)\nvoid\tLowPowerClass::idle(period_t period, adc_t adc, timer2_t timer2,\n\t\t\t\t\t\t\ttimer1_t timer1, timer0_t timer0,\n\t\t\t\t\t\t\tspi_t spi, usart0_t usart0,\ttwi_t twi)\n{\n\t// Temporary clock source variable\n\tunsigned char clockSource = 0;\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n\t\t// Store current setting\n        clockSource = TCCR2B;\n\n\t\t// Remove the clock source to shutdown Timer2\n\t\tTCCR2B &= ~(1 << CS22);\n\t\tTCCR2B &= ~(1 << CS21);\n\t\tTCCR2B &= ~(1 << CS20);\n\n\t\tpower_timer2_disable();\n\t}\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tADCSRA &= ~(1 << ADEN);\n\t\tpower_adc_disable();\n\t}\n\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_disable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_disable();\n\tif (spi == SPI_OFF)\t\t\tpower_spi_disable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_disable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_disable();\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tlowPowerBodOn(SLEEP_MODE_IDLE);\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tpower_adc_enable();\n\t\tADCSRA |= (1 << ADEN);\n\t}\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n        // Restore previous setting\n        TCCR2B = clockSource;\n        \n\t\tpower_timer2_enable();\n\t}\n\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_enable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_enable();\n\tif (spi == SPI_OFF)\t\t\tpower_spi_enable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_enable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_enable();\n}\n#endif\n\n/*******************************************************************************\n* Name: idle\n* Description: Putting ATmega32U4 into idle state. Please make sure you\n*\t\t\t   understand the implication and result of disabling module.\n*\t\t\t   Take note that Timer 2 is not available and USART0 is replaced\n* \t\t\t   with USART1 on ATmega32U4.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control:\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. timer4\t\tTimer 4 module disable control:\n*\t\t\t\t(a) TIMER4_OFF - Turn off Timer 4 module\n*\t\t\t\t(b) TIMER4_ON - Leave Timer 4 module in its default state\n*\n* 4. timer3\t\tTimer 3 module disable control:\n*\t\t\t\t(a) TIMER3_OFF - Turn off Timer 3 module\n*\t\t\t\t(b) TIMER3_ON - Leave Timer 3 module in its default state\n*\n* 5. timer1\t\tTimer 1 module disable control:\n*\t\t\t\t(a) TIMER1_OFF - Turn off Timer 1 module\n*\t\t\t\t(b) TIMER1_ON - Leave Timer 1 module in its default state\n*\n* 6. timer0\t\tTimer 0 module disable control:\n*\t\t\t\t(a) TIMER0_OFF - Turn off Timer 0 module\n*\t\t\t\t(b) TIMER0_ON - Leave Timer 0 module in its default state\n*\n* 7. spi\t\tSPI module disable control:\n*\t\t\t\t(a) SPI_OFF - Turn off SPI module\n*\t\t\t\t(b) SPI_ON - Leave SPI module in its default state\n*\n* 8. usart1\t\tUSART1 module disable control:\n*\t\t\t\t(a) USART1_OFF - Turn off USART1  module\n*\t\t\t\t(b) USART1_ON - Leave USART1 module in its default state\n*\n* 9. twi\t\tTWI module disable control:\n*\t\t\t\t(a) TWI_OFF - Turn off TWI module\n*\t\t\t\t(b) TWI_ON - Leave TWI module in its default state\n*\n* 10.usb\t\tUSB module disable control:\n*\t\t\t\t(a) USB_OFF - Turn off USB module\n*\t\t\t\t(b) USB_ON - Leave USB module in its default state\n*******************************************************************************/\n#if defined __AVR_ATmega32U4__\nvoid\tLowPowerClass::idle(period_t period, adc_t adc,\n\t\t\t\t\t\t\ttimer4_t timer4, timer3_t timer3,\n\t\t\t\t\t\t\ttimer1_t timer1, timer0_t timer0,\n\t\t\t\t\t\t\tspi_t spi, usart1_t usart1,\ttwi_t twi, usb_t usb)\n{\n\tif (adc == ADC_OFF)\n\t{\n\t\tADCSRA &= ~(1 << ADEN);\n\t\tpower_adc_disable();\n\t}\n\n\tif (timer4 == TIMER4_OFF)\tpower_timer4_disable();\n\tif (timer3 == TIMER3_OFF)\tpower_timer3_disable();\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_disable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_disable();\n\tif (spi == SPI_OFF)\t\t\tpower_spi_disable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_disable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_disable();\n\tif (usb == USB_OFF)\t\t\tpower_usb_disable();\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tlowPowerBodOn(SLEEP_MODE_IDLE);\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tpower_adc_enable();\n\t\tADCSRA |= (1 << ADEN);\n\t}\n\n\tif (timer4 == TIMER4_OFF)\tpower_timer4_enable();\n\tif (timer3 == TIMER3_OFF)\tpower_timer3_enable();\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_enable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_enable();\n\tif (spi == SPI_OFF)\t\t\tpower_spi_enable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_enable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_enable();\n\tif (usb == USB_OFF)\t\t\tpower_usb_enable();\n}\n#endif\n\n/*******************************************************************************\n* Name: idle\n* Description: Putting ATmega644P & ATmega1284P into idle state. Please make sure\n*\t\t\t   you understand the implication and result of disabling module.\n*\t\t\t   Take note that extra USART 1 compared to an ATmega328P/168.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control:\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. timer2\t\tTimer 2 module disable control:\n*\t\t\t\t(a) TIMER2_OFF - Turn off Timer 2 module\n*\t\t\t\t(b) TIMER2_ON - Leave Timer 2 module in its default state\n*\n* 4. timer1\t\tTimer 1 module disable control:\n*\t\t\t\t(a) TIMER1_OFF - Turn off Timer 1 module\n*\t\t\t\t(b) TIMER1_ON - Leave Timer 1 module in its default state\n*\n* 5. timer0\t\tTimer 0 module disable control:\n*\t\t\t\t(a) TIMER0_OFF - Turn off Timer 0 module\n*\t\t\t\t(b) TIMER0_ON - Leave Timer 0 module in its default state\n*\n* 6. spi\t\tSPI module disable control:\n*\t\t\t\t(a) SPI_OFF - Turn off SPI module\n*\t\t\t\t(b) SPI_ON - Leave SPI module in its default state\n*\n* 7. usart1\t\tUSART1 module disable control:\n*\t\t\t\t(a) USART1_OFF - Turn off USART1  module\n*\t\t\t\t(b) USART1_ON - Leave USART1 module in its default state\n*\n* 8. usart0\t\tUSART0 module disable control:\n*\t\t\t\t(a) USART0_OFF - Turn off USART0  module\n*\t\t\t\t(b) USART0_ON - Leave USART0 module in its default state\n*\n* 9. twi\t\tTWI module disable control:\n*\t\t\t\t(a) TWI_OFF - Turn off TWI module\n*\t\t\t\t(b) TWI_ON - Leave TWI module in its default state\n*\n*******************************************************************************/\n#if defined (__AVR_ATmega644P__) || defined (__AVR_ATmega1284P__)\nvoid\tLowPowerClass::idle(period_t period, adc_t adc, timer2_t timer2,\n\t\t\t\t\t\t\ttimer1_t timer1, timer0_t timer0, spi_t spi,\n\t\t\t\t\t\t\tusart1_t usart1, usart0_t usart0, twi_t twi)\n{\n\t// Temporary clock source variable\n\tunsigned char clockSource = 0;\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n\t\t// Store current setting\n        clockSource = TCCR2B;\n\n\t\t// Remove the clock source to shutdown Timer2\n\t\tTCCR2B &= ~(1 << CS22);\n\t\tTCCR2B &= ~(1 << CS21);\n\t\tTCCR2B &= ~(1 << CS20);\n\n\t\tpower_timer2_disable();\n\t}\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tADCSRA &= ~(1 << ADEN);\n\t\tpower_adc_disable();\n\t}\n\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_disable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_disable();\n\tif (spi == SPI_OFF)\t\t    power_spi_disable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_disable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_disable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_disable();\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tlowPowerBodOn(SLEEP_MODE_IDLE);\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tpower_adc_enable();\n\t\tADCSRA |= (1 << ADEN);\n\t}\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n        // Restore previous setting\n        TCCR2B = clockSource;\n\n\t\tpower_timer2_enable();\n\t}\n\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_enable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_enable();\n\tif (spi == SPI_OFF)\t\t\tpower_spi_enable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_enable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_enable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_enable();\n}\n#endif\n\n/*******************************************************************************\n* Name: idle\n* Description: Putting ATmega2560 & ATmega1280 into idle state. Please make sure\n*\t\t\t   you understand the implication and result of disabling module.\n*\t\t\t   Take note that extra Timer 5, 4, 3 compared to an ATmega328P/168.\n*\t\t\t   Also take note that extra USART 3, 2, 1 compared to an\n*\t\t\t   ATmega328P/168.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control:\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. timer5\t\tTimer 5 module disable control:\n*\t\t\t\t(a) TIMER5_OFF - Turn off Timer 5 module\n*\t\t\t\t(b) TIMER5_ON - Leave Timer 5 module in its default state\n*\n* 4. timer4\t\tTimer 4 module disable control:\n*\t\t\t\t(a) TIMER4_OFF - Turn off Timer 4 module\n*\t\t\t\t(b) TIMER4_ON - Leave Timer 4 module in its default state\n*\n* 5. timer3\t\tTimer 3 module disable control:\n*\t\t\t\t(a) TIMER3_OFF - Turn off Timer 3 module\n*\t\t\t\t(b) TIMER3_ON - Leave Timer 3 module in its default state\n*\n* 6. timer2\t\tTimer 2 module disable control:\n*\t\t\t\t(a) TIMER2_OFF - Turn off Timer 2 module\n*\t\t\t\t(b) TIMER2_ON - Leave Timer 2 module in its default state\n*\n* 7. timer1\t\tTimer 1 module disable control:\n*\t\t\t\t(a) TIMER1_OFF - Turn off Timer 1 module\n*\t\t\t\t(b) TIMER1_ON - Leave Timer 1 module in its default state\n*\n* 8. timer0\t\tTimer 0 module disable control:\n*\t\t\t\t(a) TIMER0_OFF - Turn off Timer 0 module\n*\t\t\t\t(b) TIMER0_ON - Leave Timer 0 module in its default state\n*\n* 9. spi\t\tSPI module disable control:\n*\t\t\t\t(a) SPI_OFF - Turn off SPI module\n*\t\t\t\t(b) SPI_ON - Leave SPI module in its default state\n*\n* 10.usart3\t\tUSART3 module disable control:\n*\t\t\t\t(a) USART3_OFF - Turn off USART3  module\n*\t\t\t\t(b) USART3_ON - Leave USART3 module in its default state\n*\n* 11.usart2\t\tUSART2 module disable control:\n*\t\t\t\t(a) USART2_OFF - Turn off USART2  module\n*\t\t\t\t(b) USART2_ON - Leave USART2 module in its default state\n*\n* 12.usart1\t\tUSART1 module disable control:\n*\t\t\t\t(a) USART1_OFF - Turn off USART1  module\n*\t\t\t\t(b) USART1_ON - Leave USART1 module in its default state\n*\n* 13.usart0\t\tUSART0 module disable control:\n*\t\t\t\t(a) USART0_OFF - Turn off USART0  module\n*\t\t\t\t(b) USART0_ON - Leave USART0 module in its default state\n*\n* 14.twi\t\tTWI module disable control:\n*\t\t\t\t(a) TWI_OFF - Turn off TWI module\n*\t\t\t\t(b) TWI_ON - Leave TWI module in its default state\n*\n*******************************************************************************/\n#if defined (__AVR_ATmega2560__) || defined (__AVR_ATmega1280__)\nvoid\tLowPowerClass::idle(period_t period, adc_t adc, timer5_t timer5,\n\t\t\t\t\t        timer4_t timer4, timer3_t timer3, timer2_t timer2,\n\t\t\t\t\t\t\ttimer1_t timer1, timer0_t timer0, spi_t spi,\n\t\t\t\t\t\t\tusart3_t usart3, usart2_t usart2, usart1_t usart1,\n\t\t\t                usart0_t usart0, twi_t twi)\n{\n\t// Temporary clock source variable\n\tunsigned char clockSource = 0;\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n\t\t// Store current setting\n        clockSource = TCCR2B;\n\n\t\t// Remove the clock source to shutdown Timer2\n\t\tTCCR2B &= ~(1 << CS22);\n\t\tTCCR2B &= ~(1 << CS21);\n\t\tTCCR2B &= ~(1 << CS20);\n\n\t\tpower_timer2_disable();\n\t}\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tADCSRA &= ~(1 << ADEN);\n\t\tpower_adc_disable();\n\t}\n\n\tif (timer5 == TIMER5_OFF)\tpower_timer5_disable();\n\tif (timer4 == TIMER4_OFF)\tpower_timer4_disable();\n\tif (timer3 == TIMER3_OFF)\tpower_timer3_disable();\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_disable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_disable();\n\tif (spi == SPI_OFF)\t\t    power_spi_disable();\n\tif (usart3 == USART3_OFF)\tpower_usart3_disable();\n\tif (usart2 == USART2_OFF)\tpower_usart2_disable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_disable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_disable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_disable();\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tlowPowerBodOn(SLEEP_MODE_IDLE);\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tpower_adc_enable();\n\t\tADCSRA |= (1 << ADEN);\n\t}\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n        // Restore previous setting\n        TCCR2B = clockSource;\n\n\t\tpower_timer2_enable();\n\t}\n\n\tif (timer5 == TIMER5_OFF)\tpower_timer5_enable();\n\tif (timer4 == TIMER4_OFF)\tpower_timer4_enable();\n\tif (timer3 == TIMER3_OFF)\tpower_timer3_enable();\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_enable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_enable();\n\tif (spi == SPI_OFF)\t\t\tpower_spi_enable();\n\tif (usart3 == USART3_OFF)\tpower_usart3_enable();\n\tif (usart2 == USART2_OFF)\tpower_usart2_enable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_enable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_enable();\n\tif (twi == TWI_OFF)\t\t\tpower_twi_enable();\n}\n#endif\n\n/*******************************************************************************\n* Name: idle\n* Description: Putting ATmega256RFR2 into idle state. Please make sure\n*\t\t\t   you understand the implication and result of disabling module.\n*\t\t\t   Take note that extra Timer 5, 4, 3 compared to an ATmega328P/168.\n*\t\t\t   Also take note that extra USART 1 compared to an\n*\t\t\t   ATmega328P/168.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control:\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. timer5\t\tTimer 5 module disable control:\n*\t\t\t\t(a) TIMER5_OFF - Turn off Timer 5 module\n*\t\t\t\t(b) TIMER5_ON - Leave Timer 5 module in its default state\n*\n* 4. timer4\t\tTimer 4 module disable control:\n*\t\t\t\t(a) TIMER4_OFF - Turn off Timer 4 module\n*\t\t\t\t(b) TIMER4_ON - Leave Timer 4 module in its default state\n*\n* 5. timer3\t\tTimer 3 module disable control:\n*\t\t\t\t(a) TIMER3_OFF - Turn off Timer 3 module\n*\t\t\t\t(b) TIMER3_ON - Leave Timer 3 module in its default state\n*\n* 6. timer2\t\tTimer 2 module disable control:\n*\t\t\t\t(a) TIMER2_OFF - Turn off Timer 2 module\n*\t\t\t\t(b) TIMER2_ON - Leave Timer 2 module in its default state\n*\n* 7. timer1\t\tTimer 1 module disable control:\n*\t\t\t\t(a) TIMER1_OFF - Turn off Timer 1 module\n*\t\t\t\t(b) TIMER1_ON - Leave Timer 1 module in its default state\n*\n* 8. timer0\t\tTimer 0 module disable control:\n*\t\t\t\t(a) TIMER0_OFF - Turn off Timer 0 module\n*\t\t\t\t(b) TIMER0_ON - Leave Timer 0 module in its default state\n*\n* 9. spi\t\tSPI module disable control:\n*\t\t\t\t(a) SPI_OFF - Turn off SPI module\n*\t\t\t\t(b) SPI_ON - Leave SPI module in its default state\n*\n* 10.usart1\t\tUSART1 module disable control:\n*\t\t\t\t(a) USART1_OFF - Turn off USART1  module\n*\t\t\t\t(b) USART1_ON - Leave USART1 module in its default state\n*\n* 11.usart0\t\tUSART0 module disable control:\n*\t\t\t\t(a) USART0_OFF - Turn off USART0  module\n*\t\t\t\t(b) USART0_ON - Leave USART0 module in its default state\n*\n* 12.twi\t\tTWI module disable control:\n*\t\t\t\t(a) TWI_OFF - Turn off TWI module\n*\t\t\t\t(b) TWI_ON - Leave TWI module in its default state\n*\n*******************************************************************************/\n#if defined (__AVR_ATmega256RFR2__)\nvoid\tLowPowerClass::idle(period_t period, adc_t adc, timer5_t timer5,\n\t\t\t\t\t                timer4_t timer4, timer3_t timer3, timer2_t timer2,\n\t\t\t\t\t\t\t\t\t\t\t\t\ttimer1_t timer1, timer0_t timer0, spi_t spi,\n\t\t\t\t\t\t\t\t\t\t\t\t\tusart1_t usart1,\n\t\t\t                    usart0_t usart0, twi_t twi)\n{\n\t// Temporary clock source variable\n\tunsigned char clockSource = 0;\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n\t\t// Store current setting\n        clockSource = TCCR2B;\n\n\t\t// Remove the clock source to shutdown Timer2\n\t\tTCCR2B &= ~(1 << CS22);\n\t\tTCCR2B &= ~(1 << CS21);\n\t\tTCCR2B &= ~(1 << CS20);\n\n\t\tpower_timer2_disable();\n\t}\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tADCSRA &= ~(1 << ADEN);\n\t\tpower_adc_disable();\n\t}\n\n\tif (timer5 == TIMER5_OFF)\tpower_timer5_disable();\n\tif (timer4 == TIMER4_OFF)\tpower_timer4_disable();\n\tif (timer3 == TIMER3_OFF)\tpower_timer3_disable();\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_disable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_disable();\n\tif (spi == SPI_OFF)\t\t\t  power_spi_disable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_disable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_disable();\n\tif (twi == TWI_OFF)\t\t\t  power_twi_disable();\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tlowPowerBodOn(SLEEP_MODE_IDLE);\n\n\tif (adc == ADC_OFF)\n\t{\n\t\tpower_adc_enable();\n\t\tADCSRA |= (1 << ADEN);\n\t}\n\n\tif (timer2 == TIMER2_OFF)\n\t{\n        // Restore previous setting\n        TCCR2B = clockSource;\n\n\t\tpower_timer2_enable();\n\t}\n\n\tif (timer5 == TIMER5_OFF)\tpower_timer5_enable();\n\tif (timer4 == TIMER4_OFF)\tpower_timer4_enable();\n\tif (timer3 == TIMER3_OFF)\tpower_timer3_enable();\n\tif (timer1 == TIMER1_OFF)\tpower_timer1_enable();\n\tif (timer0 == TIMER0_OFF)\tpower_timer0_enable();\n\tif (spi == SPI_OFF)\t\t\t  power_spi_enable();\n\tif (usart1 == USART1_OFF)\tpower_usart1_enable();\n\tif (usart0 == USART0_OFF)\tpower_usart0_enable();\n\tif (twi == TWI_OFF)\t\t\t  power_twi_enable();\n}\n#endif\n\n\n/*******************************************************************************\n* Name: adcNoiseReduction\n* Description: Putting microcontroller into ADC noise reduction state. This is\n*\t\t\t   a very useful state when using the ADC to achieve best and low\n*              noise signal.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control. Turning off the ADC module is\n*\t\t\t\tbasically removing the purpose of this low power mode.\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. timer2\t\tTimer 2 module disable control:\n*\t\t\t\t(a) TIMER2_OFF - Turn off Timer 2 module\n*\t\t\t\t(b) TIMER2_ON - Leave Timer 2 module in its default state\n*\n*******************************************************************************/\nvoid\tLowPowerClass::adcNoiseReduction(period_t period, adc_t adc,\n\t\t\t\t\t\t\t\t\t\t timer2_t timer2)\n{\n\t// Temporary clock source variable\n\tunsigned char clockSource = 0;\n\n\t#if !defined(__AVR_ATmega32U4__)\n\tif (timer2 == TIMER2_OFF)\n\t{\n\t\t// Store current setting\n        clockSource = TCCR2B;\n\n\t\t// Remove the clock source to shutdown Timer2\n\t\tTCCR2B &= ~(1 << CS22);\n\t\tTCCR2B &= ~(1 << CS21);\n\t\tTCCR2B &= ~(1 << CS20);\n\t}\n\t#endif\n\n\tif (adc == ADC_OFF)\tADCSRA &= ~(1 << ADEN);\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tlowPowerBodOn(SLEEP_MODE_ADC);\n\n\tif (adc == ADC_OFF) ADCSRA |= (1 << ADEN);\n\n\t#if !defined(__AVR_ATmega32U4__)\n\tif (timer2 == TIMER2_OFF)\n\t{\n        // Restore previous setting\n        TCCR2B = clockSource;\n\t}\n\t#endif\n}\n\n/*******************************************************************************\n* Name: powerDown\n* Description: Putting microcontroller into power down state. This is\n*\t\t\t   the lowest current consumption state. Use this together with\n*\t\t\t   external pin interrupt to wake up through external event\n*\t\t\t   triggering (example: RTC clockout pin, SD card detect pin).\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control. Turning off the ADC module is\n*\t\t\t\tbasically removing the purpose of this low power mode.\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. bod\t\tBrown Out Detector (BOD) module disable control:\n*\t\t\t\t(a) BOD_OFF - Turn off BOD module\n*\t\t\t\t(b) BOD_ON - Leave BOD module in its default state\n*\n*******************************************************************************/\nvoid\tLowPowerClass::powerDown(period_t period, adc_t adc, bod_t bod)\n{\n\tif (adc == ADC_OFF)\tADCSRA &= ~(1 << ADEN);\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\tif (bod == BOD_OFF)\n\t{\n\t\t#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168P__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega1284P__)\n\t\t\tlowPowerBodOff(SLEEP_MODE_PWR_DOWN);\n\t\t#else\n\t\t\tlowPowerBodOn(SLEEP_MODE_PWR_DOWN);\n\t\t#endif\n\t}\n\telse\n\t{\n\t\tlowPowerBodOn(SLEEP_MODE_PWR_DOWN);\n\t}\n\n\tif (adc == ADC_OFF) ADCSRA |= (1 << ADEN);\n}\n\n/*******************************************************************************\n* Name: powerSave\n* Description: Putting microcontroller into power save state. This is\n*\t\t\t   the lowest current consumption state after power down.\n*\t\t\t   Use this state together with an external 32.768 kHz crystal (but\n*\t\t\t   8/16 MHz crystal/resonator need to be removed) to provide an\n*\t\t\t   asynchronous clock source to Timer 2. Please take note that\n*\t\t\t   Timer 2 is also used by the Arduino core for PWM operation.\n*\t\t\t   Please refer to wiring.c for explanation. Removal of the external\n*\t\t\t   8/16 MHz crystal/resonator requires the microcontroller to run\n*\t\t\t   on its internal RC oscillator which is not so accurate for time\n*\t\t\t   critical operation.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period   Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control. Turning off the ADC module is\n*\t\t\t\tbasically removing the purpose of this low power mode.\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. bod\t\tBrown Out Detector (BOD) module disable control:\n*\t\t\t\t(a) BOD_OFF - Turn off BOD module\n*\t\t\t\t(b) BOD_ON - Leave BOD module in its default state\n*\n* 4. timer2\t\tTimer 2 module disable control:\n*\t\t\t\t(a) TIMER2_OFF - Turn off Timer 2 module\n*\t\t\t\t(b) TIMER2_ON - Leave Timer 2 module in its default state\n*\n*******************************************************************************/\nvoid\tLowPowerClass::powerSave(period_t period, adc_t adc, bod_t bod,\n\t\t\t\t\t\t\t     timer2_t timer2)\n{\n\t// Temporary clock source variable\n\tunsigned char clockSource = 0;\n\n\t#if !defined(__AVR_ATmega32U4__)\n\tif (timer2 == TIMER2_OFF)\n\t{\n\t\t// Store current setting\n        clockSource = TCCR2B;\n\n\t\t// Remove the clock source to shutdown Timer2\n\t\tTCCR2B &= ~(1 << CS22);\n\t\tTCCR2B &= ~(1 << CS21);\n\t\tTCCR2B &= ~(1 << CS20);\n\t}\n\t#endif\n\n\tif (adc == ADC_OFF)\tADCSRA &= ~(1 << ADEN);\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tif (bod == BOD_OFF)\n\t{\n\t\t#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168P__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega1284P__)\n\t\t\tlowPowerBodOff(SLEEP_MODE_PWR_SAVE);\n\t\t#else\n\t\t\tlowPowerBodOn(SLEEP_MODE_PWR_SAVE);\n\t\t#endif\n\t}\n\telse\n\t{\n\t\tlowPowerBodOn(SLEEP_MODE_PWR_SAVE);\n\t}\n\n\tif (adc == ADC_OFF) ADCSRA |= (1 << ADEN);\n\n\t#if !defined(__AVR_ATmega32U4__)\n\tif (timer2 == TIMER2_OFF)\n\t{\n        // Restore previous setting\n        TCCR2B = clockSource;\n\t}\n\t#endif\n}\n\n/*******************************************************************************\n* Name: powerStandby\n* Description: Putting microcontroller into power standby state.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control. Turning off the ADC module is\n*\t\t\t\tbasically removing the purpose of this low power mode.\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. bod\t\tBrown Out Detector (BOD) module disable control:\n*\t\t\t\t(a) BOD_OFF - Turn off BOD module\n*\t\t\t\t(b) BOD_ON - Leave BOD module in its default state\n*\n*******************************************************************************/\nvoid\tLowPowerClass::powerStandby(period_t period, adc_t adc, bod_t bod)\n{\n\tif (adc == ADC_OFF)\tADCSRA &= ~(1 << ADEN);\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\tif (bod == BOD_OFF)\n\t{\n\t\t#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168P__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega1284P__)\n\t\t\tlowPowerBodOff(SLEEP_MODE_STANDBY);\n\t\t#else\n\t\t\tlowPowerBodOn(SLEEP_MODE_STANDBY);\n\t\t#endif\n\t}\n\telse\n\t{\n\t\tlowPowerBodOn(SLEEP_MODE_STANDBY);\n\t}\n\n\tif (adc == ADC_OFF) ADCSRA |= (1 << ADEN);\n}\n\n/*******************************************************************************\n* Name: powerExtStandby\n* Description: Putting microcontroller into power extended standby state. This\n*\t\t\t   is different from the power standby state as it has the\n*\t\t\t   capability to run Timer 2 asynchronously.\n*              Not implemented on Atmega88 and Atmega168.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. period     Duration of low power mode. Use SLEEP_FOREVER to use other wake\n*\t\t\t\tup resource:\n*\t\t\t\t(a) SLEEP_15MS - 15 ms sleep\n*\t\t\t\t(b) SLEEP_30MS - 30 ms sleep\n*\t\t\t\t(c) SLEEP_60MS - 60 ms sleep\n*\t\t\t\t(d) SLEEP_120MS - 120 ms sleep\n*\t\t\t\t(e) SLEEP_250MS - 250 ms sleep\n*\t\t\t\t(f) SLEEP_500MS - 500 ms sleep\n*\t\t\t\t(g) SLEEP_1S - 1 s sleep\n*\t\t\t\t(h) SLEEP_2S - 2 s sleep\n*\t\t\t\t(i) SLEEP_4S - 4 s sleep\n*\t\t\t\t(j) SLEEP_8S - 8 s sleep\n*\t\t\t\t(k) SLEEP_FOREVER - Sleep without waking up through WDT\n*\n* 2. adc\t\tADC module disable control.\n*\t\t\t\t(a) ADC_OFF - Turn off ADC module\n*\t\t\t\t(b) ADC_ON - Leave ADC module in its default state\n*\n* 3. bod\t\tBrown Out Detector (BOD) module disable control:\n*\t\t\t\t(a) BOD_OFF - Turn off BOD module\n*\t\t\t\t(b) BOD_ON - Leave BOD module in its default state\n*\n* 4. timer2\t\tTimer 2 module disable control:\n*\t\t\t\t(a) TIMER2_OFF - Turn off Timer 2 module\n*\t\t\t\t(b) TIMER2_ON - Leave Timer 2 module in its default state\n*\n*******************************************************************************/\nvoid\tLowPowerClass::powerExtStandby(period_t period, adc_t adc, bod_t bod,\n\t\t\t\t\t\t\t\t\t   timer2_t timer2)\n{\n\t// Temporary clock source variable\n\tunsigned char clockSource = 0;\n\n\t#if !defined(__AVR_ATmega32U4__)\n\tif (timer2 == TIMER2_OFF)\n\t{\n\t\t// Store current setting\n        clockSource = TCCR2B;\n\n\t\t// Remove the clock source to shutdown Timer2\n\t\tTCCR2B &= ~(1 << CS22);\n\t\tTCCR2B &= ~(1 << CS21);\n\t\tTCCR2B &= ~(1 << CS20);\n\t}\n\t#endif\n\n\tif (adc == ADC_OFF)\tADCSRA &= ~(1 << ADEN);\n\n\tif (period != SLEEP_FOREVER)\n\t{\n\t\twdt_enable(period);\n\t\tWDTCSR |= (1 << WDIE);\n\t}\n\n\n\t#if defined (__AVR_ATmega88__) || defined (__AVR_ATmega168__) // SLEEP_MODE_EXT_STANDBY not implemented on Atmega88 / Atmega168\n\t#else\n\t\tif (bod == BOD_OFF)\n\t\t{\n\t\t\t#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168P__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega1284P__)\n\t\t\t\tlowPowerBodOff(SLEEP_MODE_EXT_STANDBY);\n\t\t\t#else\n\t\t\t\tlowPowerBodOn(SLEEP_MODE_EXT_STANDBY);\n\t\t\t#endif\n\t\t}\n\t\telse\n\t\t{\n\t\t\tlowPowerBodOn(SLEEP_MODE_EXT_STANDBY);\n\t\t}\n\t#endif\n\n\tif (adc == ADC_OFF) ADCSRA |= (1 << ADEN);\n\n\t#if !defined(__AVR_ATmega32U4__)\n\tif (timer2 == TIMER2_OFF)\n\t{\n        // Restore previous setting\n        TCCR2B = clockSource;\n\t}\n\t#endif\n}\n\n// sleep # of milliseconds using WDT (watchdog timer - accurate to within 10%, uses about 3uA)\nvoid LowPowerClass::longPowerDown(uint32_t sleepTime) {\n  do {\n    if (sleepTime > 8000)\n    {\n      powerDown(SLEEP_8S, ADC_OFF, BOD_OFF);\n      sleepTime-=8000;\n    }\n    else if (sleepTime > 4000)\n    {\n      powerDown(SLEEP_4S, ADC_OFF, BOD_OFF);\n      sleepTime-=4000;\n    }\n    else if (sleepTime > 2000)\n    {\n      powerDown(SLEEP_2S, ADC_OFF, BOD_OFF);\n      sleepTime-=2000;\n    }\n    else if (sleepTime > 1000)\n    {\n      powerDown(SLEEP_1S, ADC_OFF, BOD_OFF);\n      sleepTime-=1000;\n    }\n    else if (sleepTime > 512)\n    {\n      powerDown(SLEEP_500MS, ADC_OFF, BOD_OFF);\n      sleepTime-=512;\n    }\n    else if (sleepTime > 256)\n    {\n      powerDown(SLEEP_250MS, ADC_OFF, BOD_OFF);\n      sleepTime-=256;\n    }\n    else if (sleepTime > 128)\n    {\n      powerDown(SLEEP_120MS, ADC_OFF, BOD_OFF);\n      sleepTime-=128;\n    }\n    else if (sleepTime > 64)\n    {\n      powerDown(SLEEP_60MS, ADC_OFF, BOD_OFF);\n      sleepTime-=64;\n    }\n    else if (sleepTime > 32)\n    {\n      powerDown(SLEEP_30MS, ADC_OFF, BOD_OFF);\n      sleepTime-=32;\n    }\n    else if (sleepTime > 16)\n    {\n      powerDown(SLEEP_15MS, ADC_OFF, BOD_OFF);\n      sleepTime-=16;\n    }\n    else\n    {\n      sleepTime=0;\n    }\n  } while(sleepTime);\n}\n\n/*******************************************************************************\n* Name: ISR (WDT_vect)\n* Description: Watchdog Timer interrupt service routine. This routine is\n*\t\t       required to allow automatic WDIF and WDIE bit clearance in\n*\t\t\t   hardware.\n*\n*******************************************************************************/\nISR (WDT_vect)\n{\n\t// WDIE & WDIF is cleared in hardware upon entering this ISR\n\twdt_disable();\n}\n\n#elif defined(__arm__)\n#if defined(__SAMD21__) || defined(ARDUINO_SAMD_ZERO)\n/*******************************************************************************\n* Name: standby\n* Description: Putting SAMD21G18A into idle mode. This is the lowest current\n*              consumption mode. Requires separate handling of clock and\n* \t\t\t   peripheral management (disabling and shutting down) to achieve\n* \t\t\t   the desired current consumption.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. idleMode   Idle mode level (0, 1, 2) where IDLE_2 level provide lowest\n* \t\t\t\tcurrent consumption in this mode.\n*\n*******************************************************************************/\nvoid\tLowPowerClass::idle(idle_t idleMode)\n{\n\tSCB->SCR &= ~SCB_SCR_SLEEPDEEP_Msk;\n\tPM->SLEEP.reg = idleMode;\n\t__DSB();\n\t__WFI();\n}\n\n/*******************************************************************************\n* Name: standby\n* Description: Putting SAMD21G18A into standby mode. This is the lowest current\n*              consumption mode. Use this together with the built-in RTC (use\n*              RTCZero library) or external pin interrupt to wake up through\n*              external event triggering.\n*\n* Argument  \tDescription\n* =========  \t===========\n* 1. NIL\n*\n*******************************************************************************/\nvoid\tLowPowerClass::standby()\n{\n\tSCB->SCR |= SCB_SCR_SLEEPDEEP_Msk;\n\t__DSB();\n\t__WFI();\n}\n\n#else\n\t#error \"Please ensure chosen MCU is a SAMD21\"\n#endif\n#else\n\t#error \"Processor architecture is not supported.\"\n#endif\n\nLowPowerClass LowPower;"
    }, {
      filename: "src/LowPower.h",
      code: "#ifndef LowPower_h\n#define LowPower_h\n\n#include \"Arduino.h\"\n\nenum period_t\n{\n\tSLEEP_15MS,\n\tSLEEP_30MS,\n\tSLEEP_60MS,\n\tSLEEP_120MS,\n\tSLEEP_250MS,\n\tSLEEP_500MS,\n\tSLEEP_1S,\n\tSLEEP_2S,\n\tSLEEP_4S,\n\tSLEEP_8S,\n\tSLEEP_FOREVER\n};\n\nenum bod_t\n{\n\tBOD_OFF,\n\tBOD_ON\n};\n\nenum adc_t\n{\n\tADC_OFF,\n\tADC_ON\n};\n\nenum timer5_t\n{\n\tTIMER5_OFF,\n\tTIMER5_ON\n};\n\nenum timer4_t\n{\n\tTIMER4_OFF,\n\tTIMER4_ON\n};\n\nenum timer3_t\n{\n\tTIMER3_OFF,\n\tTIMER3_ON\n};\n\nenum timer2_t\n{\n\tTIMER2_OFF,\n\tTIMER2_ON\n};\n\nenum timer1_t\n{\n\tTIMER1_OFF,\n\tTIMER1_ON\n};\n\nenum timer0_t\n{\n\tTIMER0_OFF,\n\tTIMER0_ON\n};\n\nenum spi_t\n{\n\tSPI_OFF,\n\tSPI_ON\n};\n\nenum usart0_t\n{\n\tUSART0_OFF,\n\tUSART0_ON\n};\n\nenum usart1_t\n{\n\tUSART1_OFF,\n\tUSART1_ON\n};\n\nenum usart2_t\n{\n\tUSART2_OFF,\n\tUSART2_ON\n};\n\nenum usart3_t\n{\n\tUSART3_OFF,\n\tUSART3_ON\n};\n\nenum twi_t\n{\n\tTWI_OFF,\n\tTWI_ON\n};\n\nenum usb_t\n{\n\tUSB_OFF,\n\tUSB_ON\n};\n\nenum idle_t\n{\n\tIDLE_0,\n\tIDLE_1,\n\tIDLE_2\n};\n\nclass LowPowerClass\n{\n\tpublic:\n\t\t#if defined (__AVR__)\n\n\t\t\t#if defined (__AVR_ATmega328P__) || defined (__AVR_ATmega168__) || defined (__AVR_ATmega168P__) || defined (__AVR_ATmega88__)\n\t\t\t\tvoid\tidle(period_t period, adc_t adc, timer2_t timer2,\n\t\t\t\t\t\t     timer1_t timer1, timer0_t timer0, spi_t spi,\n\t\t\t\t\t         usart0_t usart0, twi_t twi);\n\t\t\t#elif defined __AVR_ATmega644P__ || defined (__AVR_ATmega1284P__)\n\t\t\t\tvoid\tidle(period_t period, adc_t adc, timer2_t timer2,\n\t\t\t\t\t\t\t timer1_t timer1, timer0_t timer0, spi_t spi,\n\t\t\t\t\t\t\t usart1_t usart1, usart0_t usart0, twi_t twi);\n\t\t\t#elif defined __AVR_ATmega2560__\n\t\t\t\tvoid\tidle(period_t period, adc_t adc, timer5_t timer5,\n\t\t\t\t\t\t\t timer4_t timer4, timer3_t timer3, timer2_t timer2,\n\t\t\t\t\t\t\t timer1_t timer1, timer0_t timer0, spi_t spi,\n\t\t\t\t\t\t\t usart3_t usart3, usart2_t usart2, usart1_t usart1,\n\t\t\t\t\t\t\t usart0_t usart0, twi_t twi);\n\t\t\t#elif defined __AVR_ATmega256RFR2__\n\t\t\t\tvoid\tidle(period_t period, adc_t adc, timer5_t timer5,\n\t\t\t\t\t\t\t\t\t timer4_t timer4, timer3_t timer3, timer2_t timer2,\n\t\t\t\t   \t\t\t\t timer1_t timer1, timer0_t timer0, spi_t spi,\n\t\t\t\t\t\t       usart1_t usart1,\n\t\t\t\t\t\t\t\t\t usart0_t usart0, twi_t twi);\n\t\t\t#elif defined __AVR_ATmega32U4__\n\t\t\t\tvoid\tidle(period_t period, adc_t adc, timer4_t timer4,\n\t\t\t\t             timer3_t timer3, timer1_t timer1, timer0_t timer0,\n\t\t\t\t             spi_t spi, usart1_t usart1, twi_t twi, usb_t usb);\n\t\t\t#else\n\t\t\t\t#error \"Please ensure chosen MCU is either 88, 168, 168P, 328P, 32U4, 2560 or 256RFR2.\"\n\t\t\t#endif\n\t\t\tvoid\tadcNoiseReduction(period_t period, adc_t adc, timer2_t timer2) __attribute__((optimize(\"-O1\")));\n\t\t\tvoid\tpowerDown(period_t period, adc_t adc, bod_t bod) __attribute__((optimize(\"-O1\")));\n\t\t\tvoid\tpowerSave(period_t period, adc_t adc, bod_t bod, timer2_t timer2) __attribute__((optimize(\"-O1\")));\n\t\t\tvoid\tpowerStandby(period_t period, adc_t adc, bod_t bod) __attribute__((optimize(\"-O1\")));\n\t\t\tvoid\tpowerExtStandby(period_t period, adc_t adc, bod_t bod, timer2_t timer2) __attribute__((optimize(\"-O1\")));\n      void  longPowerDown(uint32_t sleepTime);\n\t\t#elif defined (__arm__)\n\t\t\t#if defined(__SAMD21__) || defined(ARDUINO_SAMD_ZERO)\n\t\t\t\tvoid\tidle(idle_t idleMode);\n\t\t\t\tvoid\tstandby();\n\t\t\t#else\n\t\t\t\t#error \"Please ensure chosen MCU is a SAMD21\"\n\t\t\t#endif\n\n\t\t#else\n\n\t\t\t#error \"Processor architecture is not supported.\"\n\n\t\t#endif\n};\n\nextern LowPowerClass LowPower;\n#endif"
    }]
  };
  const extFacePanels = {};
  const ExtHandler = {
    onLoad: function onLoad(app, target) {
      const that = this;

      if (!that.__workerSetupInstance) {
        that.__workerSetupInstance = that.workerSetup({
          app
        }).then(() => {
          that.worker.remote.runExtension('onLoad', target.id);
        });
      }
    },
    onUnload: function onUnload(app) {
      this.__workerSetupInstance = null;
      this.worker.remote.runExtension('onUnload');
      this.worker.dispose();
    },
    onConnect: function onConnect(app, device) {
      this.worker.remote.runExtension('onConnect', device.id);
    },
    onDisconnect: function onDisconnect(app, device) {
      this.worker.remote.runExtension('onDisconnect', device.id);
    },
    onStopAll: function onStopAll(app, device) {
      this.worker.remote.runExtension('onStopAll', device.id);
    },
    beforeChangeUploadMode: function beforeChangeUploadMode(app, device) {
      return this.worker.remote.runExtension('beforeChangeUploadMode', device.id);
    },
    beforeChangeDebugMode: function beforeChangeDebugMode(app, device) {
      return this.worker.remote.runExtension('beforeChangeDebugMode', device.id);
    },
    afterChangeUploadMode: function afterChangeUploadMode(app, device) {
      this.worker.remote.runExtension('afterChangeUploadMode', device.id);
    },
    afterChangeDebugMode: function afterChangeDebugMode(app, device) {
      this.worker.remote.runExtension('afterChangeDebugMode', device.id);
    },
    onSelect: function onSelect(app, device) {
      if (!this.worker) {
        setTimeout(() => {
          this.onSelect(app, device);
        }, 200);
        return;
      }

      this.worker.remote.runExtension('onSelect', device.id);
    },
    onUnselect: function onUnselect(app, device) {
      this.worker.remote.runExtension('onUnselect', device.id);
    },
    beforeCodeUpload: function beforeCodeUpload(app, device) {
      this.worker.remote.runExtension('beforeCodeUpload', device.id);
    },
    afterCodeUpload: function afterCodeUpload(app, device) {
      this.worker.remote.runExtension('afterCodeUpload', device.id);
    },
    onRead: function onRead(app, device) {
      this.worker.remote.runExtension('onRead', device.id);
    },
    beforeFirmwareUpdate: function beforeFirmwareUpdate(app, device) {
      this.worker.remote.runExtension('beforeFirmwareUpdate', device.id);
    },
    afterFirmwareUpdate: function afterFirmwareUpdate(app, device) {
      this.worker.remote.runExtension('afterFirmwareUpdate', device.id);
    }
  };

  class ExtVdrGroveDivers {
    constructor() {
      this.checkFirmwareInForce = typeof checkFirmwareInForce !== 'undefined' ? checkFirmwareInForce : false;
      const handlerProxyUrl = window.MbApi.getExtResPath('vdr_grove_divers/handlerProxy.js', 'vdr_grove_divers');
      const that = this;

      that.workerSetup = async function (exports) {
        that.worker = await window.__web_worker_rpc.create(handlerProxyUrl, exports).then(worker => {
          worker.CONFIG.TIMEOUT = 42000;
          worker.CONFIG.HEARTBEAT = 4200;

          worker.onFail = () => {
            that.worker = null;
            that.workerSetup(exports);
            const app = exports.app;

            if (app) {
              app.workspace.resetEvents();
            }
          };

          return worker;
        });
      };

      this.funcs = {
        'BLOCK_1654891253229': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891253229', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1654891387215': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891387215', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1654891387430': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891387430', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1654891387629': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891387629', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1654891387838': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891387838', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1654891388053': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891388053', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1654891388253': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891388253', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1654891388445': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1654891388445', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        }
      };
    }

    getInfo() {
      return {
        "id": "vdr_grove_divers",
        "targets": [{
          "name": "arduino_mega2560",
          "options": {
            "upload": {
              "middlewares": [{
                "name": "arduino",
                "params": {
                  "sources": extSources.arduino
                }
              }]
            }
          }
        }, {
          "name": "arduino_uno",
          "options": {
            "upload": {
              "middlewares": [{
                "name": "arduino",
                "params": {
                  "sources": extSources.arduino
                }
              }]
            }
          }
        }],
        "codeTypes": ["arduinoc"],
        "version": "1.0.0",
        "platform": ["mblockpc"],
        "categories": [{
          "name": "cate_a6173b07",
          "colors": ["#7ED321", "#71BE1E", "#65A91A"],
          "menuIconURI": "",
          "blockIcon": {
            "type": "image",
            "width": 28,
            "height": 26,
            "src": window.MbApi.getExtResPath('vdr_grove_divers/imgs/6c1edb5f7d104e018ed377bd1a7f60a7.png', 'vdr_grove_divers')
          },
          "blocks": [{
            "opcode": "BLOCK_1654891253229",
            "blockType": "command",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {},
            "branchCount": 0,
            "handler": this.funcs.BLOCK_1654891253229
          }, {
            "opcode": "BLOCK_1654891387215",
            "blockType": "conditional",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "forVar": {
                "type": "inputVariable",
                "defaultValue": ""
              },
              "min": {
                "type": "number",
                "defaultValue": 1
              },
              "max": {
                "type": "number",
                "defaultValue": 10
              },
              "step": {
                "type": "number",
                "defaultValue": 1
              }
            },
            "branchCount": 1,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `   for (int /*{forVar}*/=/*{min}*/ ; /*{forVar}*/<=/*{max}*/ ; /*{forVar}*/+=/*{step}*/) {\r\n       /*{$BRANCH1}*/ \r\n   }\r\n   `
              }
            },
            "handler": this.funcs.BLOCK_1654891387215
          }, {
            "opcode": "BLOCK_1654891387430",
            "blockType": "command",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {
              "num": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891387430_NUM"
              }
            },
            "branchCount": 0,
            "codes": {
              "arduinoc": {
                "code": `tempsDepart/*{num}*/=millis();`,
                "sections": {
                  "declare": `unsigned long tempsDepart/*{num}*/ = 0;                        \r`
                }
              }
            },
            "handler": this.funcs.BLOCK_1654891387430
          }, {
            "opcode": "BLOCK_1654891387629",
            "blockType": "boolean",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {
              "num": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891387430_NUM"
              },
              "time": {
                "type": "number",
                "defaultValue": 1000
              }
            },
            "branchCount": 0,
            "codes": {
              "arduinoc": {
                "code": `((tempsDepart/*{num}*/ + /*{time}*/) < millis())`
              }
            },
            "handler": this.funcs.BLOCK_1654891387629
          }, {
            "opcode": "BLOCK_1654891387838",
            "blockType": "command",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "pinsDigit": {
                "type": "fieldMenu",
                "defaultValue": "2",
                "menu": "BLOCK_1654891387838_PINSDIGIT"
              },
              "onOff": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891387838_ONOFF"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `SetPinState(/*{pinsDigit}*/,/*{onOff}*/);`,
                "sections": {
                  "declare": `void SetPinState(int n,int val){\r\n    if(val==2){\r\n        if(digitalRead(n)){\r\n            digitalWrite(n, LOW);\r\n        }\r\n        else{\r\n            digitalWrite(n, HIGH);\r\n        }\r\n        delay(100);\r\n    }else{\r\n        digitalWrite(n, val);\r\n    }\r\n}`,
                  "setup": `pinMode(/*{pinsDigit}*/,OUTPUT);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1654891387838
          }, {
            "opcode": "BLOCK_1654891388053",
            "blockType": "boolean",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {
              "pinsDigit": {
                "type": "fieldMenu",
                "defaultValue": "2",
                "menu": "BLOCK_1654891387838_PINSDIGIT"
              },
              "etat": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891388053_ETAT"
              }
            },
            "branchCount": 0,
            "codes": {
              "arduinoc": {
                "code": `digitalInputState (/*{pinsDigit}*/,/*{etat}*/)`,
                "sections": {
                  "declare": `bool digitalInputState (int pinNum , bool state) {\r\n    if (state) return digitalRead(pinNum);\r\n    else return !digitalRead(pinNum);\r\n}`,
                  "setup": `pinMode(/*{pinsDigit}*/,INPUT);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1654891388053
          }, {
            "opcode": "BLOCK_1654891388253",
            "blockType": "number",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {
              "pinAnalogique": {
                "type": "fieldMenu",
                "defaultValue": "A0",
                "menu": "BLOCK_1654891388253_PINANALOGIQUE"
              },
              "Grove_VCC": {
                "type": "fieldMenu",
                "defaultValue": "5",
                "menu": "BLOCK_1654891388253_GROVE_VCC"
              },
              "angleMax": {
                "type": "number",
                "defaultValue": 100
              }
            },
            "branchCount": 0,
            "codes": {
              "arduinoc": {
                "code": `GetAnglePotentiometre()`,
                "sections": {
                  "declare": `#define ROTARY_ANGLE_SENSOR /*{pinAnalogique}*/\r\n#define GROVE_VCC /*{Grove_VCC}*/\r\n#define FULL_ANGLE /*{angleMax}*/ //full value of the rotary angle is 300 degrees\r\n#define ADC_REF 5 \r\n\r\nint GetAnglePotentiometre(){\r\n  int sensor_value = analogRead(ROTARY_ANGLE_SENSOR);\r\n  return round(((float)sensor_value*ADC_REF/1023)*FULL_ANGLE/GROVE_VCC);\r\n}`,
                  "setup": ` pinMode(ROTARY_ANGLE_SENSOR, INPUT);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1654891388253
          }, {
            "opcode": "BLOCK_1654891388445",
            "blockType": "command",
            "checkboxInFlyout": false,
            "gap": 12,
            "arguments": {
              "pinDigit": {
                "type": "fieldMenu",
                "defaultValue": "2",
                "menu": "BLOCK_1654891387838_PINSDIGIT"
              },
              "note": {
                "type": "fieldMenu",
                "defaultValue": "1915",
                "menu": "BLOCK_1654891388445_NOTE"
              },
              "duree": {
                "type": "number",
                "defaultValue": 1
              }
            },
            "branchCount": 0,
            "codes": {
              "arduinoc": {
                "code": `grove_buzzer_play_tone(/*{pinDigit}*/, /*{note}*/, /*{duree}*/*1000);`,
                "sections": {
                  "declare": `void grove_buzzer_play_tone(int pin, int tone, int duration) { \r\n    for (long i = 0; i < duration * 1000L; i += tone * 2) {\r\n        digitalWrite(pin, HIGH);\r\n        delayMicroseconds(tone);\r\n        digitalWrite(pin, LOW);\r\n        delayMicroseconds(tone);\r\n    }\r\n}`,
                  "setup": `pinMode(/*{pinDigit}*/,OUTPUT);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1654891388445
          }],
          "menus": {
            "BLOCK_1654891387430_NUM": [{
              "text": "BLOCK_1654891387430_NUM_0",
              "value": "1"
            }, {
              "text": "BLOCK_1654891387430_NUM_1",
              "value": "2"
            }, {
              "text": "BLOCK_1654891387430_NUM_2",
              "value": "3"
            }, {
              "text": "BLOCK_1654891387430_NUM_3",
              "value": "4"
            }, {
              "text": "BLOCK_1654891387430_NUM_4",
              "value": "5"
            }, {
              "text": "BLOCK_1654891387430_NUM_5",
              "value": "6"
            }, {
              "text": "BLOCK_1654891387430_NUM_6",
              "value": "7"
            }, {
              "text": "BLOCK_1654891387430_NUM_7",
              "value": "8"
            }, {
              "text": "BLOCK_1654891387430_NUM_8",
              "value": "9"
            }],
            "BLOCK_1654891387838_PINSDIGIT": [{
              "text": "BLOCK_1654891387838_PINSDIGIT_0",
              "value": "2"
            }, {
              "text": "BLOCK_1654891387838_PINSDIGIT_1",
              "value": "3"
            }, {
              "text": "BLOCK_1654891387838_PINSDIGIT_2",
              "value": "4"
            }, {
              "text": "BLOCK_1654891387838_PINSDIGIT_3",
              "value": "5"
            }, {
              "text": "BLOCK_1654891387838_PINSDIGIT_4",
              "value": "6"
            }, {
              "text": "BLOCK_1654891387838_PINSDIGIT_5",
              "value": "7"
            }, {
              "text": "BLOCK_1654891387838_PINSDIGIT_6",
              "value": "8"
            }],
            "BLOCK_1654891387838_ONOFF": [{
              "text": "BLOCK_1654891387838_ONOFF_0",
              "value": "1"
            }, {
              "text": "BLOCK_1654891387838_ONOFF_1",
              "value": "0"
            }, {
              "text": "BLOCK_1654891387838_ONOFF_2",
              "value": "2"
            }],
            "BLOCK_1654891388053_ETAT": [{
              "text": "BLOCK_1654891388053_ETAT_0",
              "value": "1"
            }, {
              "text": "BLOCK_1654891388053_ETAT_1",
              "value": "0"
            }],
            "BLOCK_1654891388253_PINANALOGIQUE": [{
              "text": "BLOCK_1654891388253_PINANALOGIQUE_0",
              "value": "A0"
            }, {
              "text": "BLOCK_1654891388253_PINANALOGIQUE_1",
              "value": "A1"
            }, {
              "text": "BLOCK_1654891388253_PINANALOGIQUE_2",
              "value": "A2"
            }, {
              "text": "BLOCK_1654891388253_PINANALOGIQUE_3",
              "value": "A3"
            }],
            "BLOCK_1654891388253_GROVE_VCC": [{
              "text": "BLOCK_1654891388253_GROVE_VCC_0",
              "value": "3.5"
            }, {
              "text": "BLOCK_1654891388253_GROVE_VCC_1",
              "value": "5"
            }],
            "BLOCK_1654891388445_NOTE": [{
              "text": "BLOCK_1654891388445_NOTE_0",
              "value": "1915"
            }, {
              "text": "BLOCK_1654891388445_NOTE_1",
              "value": "1700"
            }, {
              "text": "BLOCK_1654891388445_NOTE_2",
              "value": "1519"
            }, {
              "text": "BLOCK_1654891388445_NOTE_3",
              "value": "1432"
            }, {
              "text": "BLOCK_1654891388445_NOTE_4",
              "value": "1275"
            }, {
              "text": "BLOCK_1654891388445_NOTE_5",
              "value": "1136"
            }, {
              "text": "BLOCK_1654891388445_NOTE_6",
              "value": "1074"
            }]
          }
        }],
        "generators": extGenerators,
        "translationMap": extTranslationMap,
        "snippets": codeSnippets,
        "generatorStartBlocks": [],
        "feature": ["worker"],
        "mustLoginBlocks": [],
        "disabledOffline": [],
        "disabledOnline": []
      };
    }

    getHandler() {
      if (typeof ExtHandler === 'object') {
        return ExtHandler;
      } else if (typeof ExtHandler === 'function') {
        return new ExtHandler();
      }
    }

  }

  var _default = ExtVdrGroveDivers;
  _exports.default = _default;
});