const blocks = (extFacePanels) => ([{
        "opcode": "BLOCK_1654891253229",
        "blockType": "command",
        "checkboxInFlyout": false,
        "gap": 12,
        "arguments": {},
        "branchCount": 0,
        "handler": this.funcs.BLOCK_1654891253229
    },
    {
        "opcode": "BLOCK_1654891387215",
        "blockType": "conditional",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "forVar": {
                "type": "inputVariable",
                "defaultValue": ""
            },
            "min": {
                "type": "number",
                "defaultValue": 1
            },
            "max": {
                "type": "number",
                "defaultValue": 10
            },
            "step": {
                "type": "number",
                "defaultValue": 1
            }
        },
        "branchCount": 1,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `   for (int /*{forVar}*/=/*{min}*/ ; /*{forVar}*/<=/*{max}*/ ; /*{forVar}*/+=/*{step}*/) {\r\n       /*{$BRANCH1}*/ \r\n   }\r\n   `
            }
        },
        "handler": this.funcs.BLOCK_1654891387215
    },
    {
        "opcode": "BLOCK_1654891387430",
        "blockType": "command",
        "checkboxInFlyout": false,
        "gap": 12,
        "arguments": {
            "num": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891387430_NUM"
            }
        },
        "branchCount": 0,
        "codes": {
            "arduinoc": {
                "code": `tempsDepart/*{num}*/=millis();`,
                "sections": {
                    "declare": `unsigned long tempsDepart/*{num}*/ = 0;                        \r`
                }
            }
        },
        "handler": this.funcs.BLOCK_1654891387430
    },
    {
        "opcode": "BLOCK_1654891387629",
        "blockType": "boolean",
        "checkboxInFlyout": false,
        "gap": 12,
        "arguments": {
            "num": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891387430_NUM"
            },
            "time": {
                "type": "number",
                "defaultValue": 1000
            }
        },
        "branchCount": 0,
        "codes": {
            "arduinoc": {
                "code": `((tempsDepart/*{num}*/ + /*{time}*/) < millis())`
            }
        },
        "handler": this.funcs.BLOCK_1654891387629
    },
    {
        "opcode": "BLOCK_1654891387838",
        "blockType": "command",
        "checkboxInFlyout": false,
        "hidden": false,
        "gap": 12,
        "arguments": {
            "pinsDigit": {
                "type": "fieldMenu",
                "defaultValue": "2",
                "menu": "BLOCK_1654891387838_PINSDIGIT"
            },
            "onOff": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891387838_ONOFF"
            }
        },
        "branchCount": 0,
        "platform": [
            "mblockpc",
            "mblockweb"
        ],
        "codes": {
            "arduinoc": {
                "code": `SetPinState(/*{pinsDigit}*/,/*{onOff}*/);`,
                "sections": {
                    "declare": `void SetPinState(int n,int val){\r\n    if(val==2){\r\n        if(digitalRead(n)){\r\n            digitalWrite(n, LOW);\r\n        }\r\n        else{\r\n            digitalWrite(n, HIGH);\r\n        }\r\n        delay(100);\r\n    }else{\r\n        digitalWrite(n, val);\r\n    }\r\n}`,
                    "setup": `pinMode(/*{pinsDigit}*/,OUTPUT);`
                }
            }
        },
        "handler": this.funcs.BLOCK_1654891387838
    },
    {
        "opcode": "BLOCK_1654891388053",
        "blockType": "boolean",
        "checkboxInFlyout": false,
        "gap": 12,
        "arguments": {
            "pinsDigit": {
                "type": "fieldMenu",
                "defaultValue": "2",
                "menu": "BLOCK_1654891387838_PINSDIGIT"
            },
            "etat": {
                "type": "fieldMenu",
                "defaultValue": "1",
                "menu": "BLOCK_1654891388053_ETAT"
            }
        },
        "branchCount": 0,
        "codes": {
            "arduinoc": {
                "code": `digitalInputState (/*{pinsDigit}*/,/*{etat}*/)`,
                "sections": {
                    "declare": `bool digitalInputState (int pinNum , bool state) {\r\n    if (state) return digitalRead(pinNum);\r\n    else return !digitalRead(pinNum);\r\n}`,
                    "setup": `pinMode(/*{pinsDigit}*/,INPUT);`
                }
            }
        },
        "handler": this.funcs.BLOCK_1654891388053
    },
    {
        "opcode": "BLOCK_1654891388253",
        "blockType": "number",
        "checkboxInFlyout": false,
        "gap": 12,
        "arguments": {
            "pinAnalogique": {
                "type": "fieldMenu",
                "defaultValue": "A0",
                "menu": "BLOCK_1654891388253_PINANALOGIQUE"
            },
            "Grove_VCC": {
                "type": "fieldMenu",
                "defaultValue": "5",
                "menu": "BLOCK_1654891388253_GROVE_VCC"
            },
            "angleMax": {
                "type": "number",
                "defaultValue": 100
            }
        },
        "branchCount": 0,
        "codes": {
            "arduinoc": {
                "code": `GetAnglePotentiometre()`,
                "sections": {
                    "declare": `#define ROTARY_ANGLE_SENSOR /*{pinAnalogique}*/\r\n#define GROVE_VCC /*{Grove_VCC}*/\r\n#define FULL_ANGLE /*{angleMax}*/ //full value of the rotary angle is 300 degrees\r\n#define ADC_REF 5 \r\n\r\nint GetAnglePotentiometre(){\r\n  int sensor_value = analogRead(ROTARY_ANGLE_SENSOR);\r\n  return round(((float)sensor_value*ADC_REF/1023)*FULL_ANGLE/GROVE_VCC);\r\n}`,
                    "setup": ` pinMode(ROTARY_ANGLE_SENSOR, INPUT);`
                }
            }
        },
        "handler": this.funcs.BLOCK_1654891388253
    },
    {
        "opcode": "BLOCK_1654891388445",
        "blockType": "command",
        "checkboxInFlyout": false,
        "gap": 12,
        "arguments": {
            "pinDigit": {
                "type": "fieldMenu",
                "defaultValue": "2",
                "menu": "BLOCK_1654891387838_PINSDIGIT"
            },
            "note": {
                "type": "fieldMenu",
                "defaultValue": "1915",
                "menu": "BLOCK_1654891388445_NOTE"
            },
            "duree": {
                "type": "number",
                "defaultValue": 1
            }
        },
        "branchCount": 0,
        "codes": {
            "arduinoc": {
                "code": `grove_buzzer_play_tone(/*{pinDigit}*/, /*{note}*/, /*{duree}*/*1000);`,
                "sections": {
                    "declare": `void grove_buzzer_play_tone(int pin, int tone, int duration) { \r\n    for (long i = 0; i < duration * 1000L; i += tone * 2) {\r\n        digitalWrite(pin, HIGH);\r\n        delayMicroseconds(tone);\r\n        digitalWrite(pin, LOW);\r\n        delayMicroseconds(tone);\r\n    }\r\n}`,
                    "setup": `pinMode(/*{pinDigit}*/,OUTPUT);`
                }
            }
        },
        "handler": this.funcs.BLOCK_1654891388445
    }
]);

export default blocks;